local addonName = ...
local f = CreateFrame("Frame")

-- local function SetupStatusBarText(bar, parent)
--     local text, left, right =
--         parent:CreateFontString(nil, "OVERLAY", "TextStatusBarText"),
--         parent:CreateFontString(nil, "OVERLAY", "TextStatusBarText"),
--         parent:CreateFontString(nil, "OVERLAY", "TextStatusBarText")
--     text:SetPoint("CENTER", bar, "CENTER")
--     left:SetPoint("LEFT", bar, "LEFT", 2, 0)
--     right:SetPoint("RIGHT", bar, "RIGHT", -2, 0)
--     bar.TextString, bar.LeftText, bar.RightText = text, left, right
-- end

--  SetupStatusBarText(TargetFrameHealthBar, TargetFrameTextureFrame)
--  SetupStatusBarText(TargetFrameManaBar, TargetFrameTextureFrame)
f:RegisterEvent("ADDON_LOADED")
f:SetScript(
    "OnEvent",
    function(self, event, arg1)
        
        if (addonName == arg1) then
        PlayerName:SetTextColor(1, 1, 1)
        PlayerHitIndicator.SetText = function()
        end
        PlayerName:SetAlpha(0)
        PlayerPVPIcon:SetAlpha(0)
        PlayerPVPIconHitArea:Hide()
        TargetFrameTextureFrameName:SetTextColor(1, 1, 1)
        TargetFrameToTTextureFrameName:SetTextColor(1, 1, 1)
        TargetFrameTextureFramePVPIcon:SetAlpha(0)
        -- TargetFrameSpellBar.Border:Hide()
        -- TargetFrameToTPortrait:SetSize(39, 39)

        -- TargetFrameToTPortrait:SetPoint("TOPLEFT", TargetFrameToT, "TOPLEFT", 3, -3)
        -- TargetFrameToTBackground:SetPoint("BOTTOMLEFT", 44, 13)
    
        PlayerFrameFlash:Hide(); PlayerFrameFlash.Show = function() end
        -- TargetFrameFlash:Hide(); TargetFrameFlash.Show = function() end
        --Pet frame
        -- PetName:SetTextColor(1, 1, 1)
        -- PetHitIndicator:SetText(nil)
        -- PetHitIndicator.SetText = function()
        -- end

        -- class colored name background
            local frame = CreateFrame("FRAME")
            local c
            frame:RegisterEvent("PLAYER_TARGET_CHANGED")
            frame:SetScript(
                "OnEvent",
                function(self, event, ...)
                    if UnitIsPlayer("target") then
                        c = RAID_CLASS_COLORS[select(2, UnitClass("target"))]    
                        TargetFrameHealthBar:SetStatusBarColor(c.r, c.g, c.b)
                    end
                end
            )
         
            c = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
            PlayerFrameHealthBar:SetStatusBarColor(c.r, c.g, c.b)
              
        end
        -- TargetFrameNameBackground:SetTexture("Interface\\TargetingFrame\\UI-StatusBar")
        TargetFrameToTBackground:SetAlpha(0)
        --TargetFrameToTTextureFrameTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetofTargetFrame");
		--TargetFrameToTHealthBar:SetHeight(8)

        local frame2 = CreateFrame("FRAME")
        frame2:RegisterEvent("UNIT_EXITED_VEHICLE")
        frame2:SetScript(
            "OnEvent",
            function(self, event, ...)
                local unitToken = ...;
                if (unitToken == "player") then
                    PlayerFrameHealthBar:SetSize(117, 23)
                    PlayerFrameHealthBar:SetPoint("TOPLEFT", 108, -28)
                    PlayerFrameManaBar:SetPoint("TOPLEFT", 108, -51)
                    PlayerFrameManaBar:SetSize(117, 10)
                end
            end
        )
        hooksecurefunc(
            "PlayerFrame_UpdateStatus",
            function()
                PlayerFrameHealthBar:SetSize(117, 23)
                PlayerFrameHealthBar:SetPoint("TOPLEFT", 108, -28)
                PlayerFrameManaBar:SetPoint("TOPLEFT", 108, -51)
                PlayerFrameManaBar:SetSize(117, 10)
                PlayerFrameManaBar.LeftText:SetAlpha(0)
                PlayerFrameManaBar.RightText:SetPoint("CENTER", 2, -6)
                PlayerFrameHealthBar.LeftText:SetAlpha(0)
                PlayerFrameHealthBar.RightText:SetPoint("CENTER", 2 , 10)
                PlayerFrameHealthBar.RightText:SetPoint("RIGHT", -8, 4)
                PlayerName:ClearAllPoints()
                PlayerName:SetPoint("CENTER", PlayerFrame, "CENTER", 50.5, 36)
            
                --PlayerStatusTexture:SetTexture([[Interface\Addons\GoodmanUi\Textures\UI-Player-Status]])
                PlayerAttackIcon:Hide()
                PlayerAttackBackground:Hide()
                PlayerStatusTexture:Hide()
                PlayerAttackGlow:Hide()
                PlayerStatusGlow:Hide()
                PlayerRestIcon:Hide()
                PlayerRestGlow:Hide()
                PlayerLevelText:Hide()
            end
        )
        local function setUnitReaction(healthbar, unit)
            if (unit == "player" or healthbar.unit == "player") then
                if (UnitExists(unit) and UnitIsPlayer(unit)) then
                    local c = RAID_CLASS_COLORS[select(2, UnitClass("player"))]
                    healthbar:SetStatusBarColor(c.r, c.g, c.b)
                    
                    return
                end
            end
           
            if (unit == "target" and healthbar.unit ~= "player") then
                if (UnitExists(unit) and UnitIsPlayer(unit)) then
                    local c = RAID_CLASS_COLORS[select(2, UnitClass("target"))]
                    healthbar:SetStatusBarColor(c.r, c.g, c.b)
                end
                if (UnitExists(unit) and not UnitIsPlayer(unit)) then
                    if (UnitIsTapDenied(unit) and not UnitPlayerControlled(unit)) then
                        healthbar:SetStatusBarColor(0.5, 0.5, 0.5)
                    elseif (not UnitIsTapDenied(unit)) then
                        local reaction = FACTION_BAR_COLORS[UnitReaction(unit, "player")]
                        if reaction then
                            healthbar:SetStatusBarColor(reaction.r, reaction.g, reaction.b)
                        else
                            healthbar:SetStatusBarColor(0, 0.6, 0.1)
                        end
                    end
                end
            end
        end
        hooksecurefunc("UnitFrameHealthBar_Update", setUnitReaction)
        hooksecurefunc(
            "HealthBar_OnValueChanged",
            function(self)
               setUnitReaction(self, self.unit)
            end
        )
        hooksecurefunc(
            "TargetFrame_CheckClassification",
            function(self, forceNormalTexture)
                local classification = UnitClassification(self.unit)
                TargetFrameBackground:Hide()
                TargetFrameTextureFrameLevelText:SetPoint("RIGHT", -30, -20)
                --TargetFrameTextureFrameLevelText:SetAlpha(0)
                -- if (classification == "minus") then
                --     self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame-Minus")
                --     self.borderTexture:SetVertexColor(.05, .05, .05)
                --     self.nameBackground:Hide()
                --     self.manabar.pauseUpdates = true
                --     self.manabar:Hide()
                --     self.manabar.TextString:Hide()
                --     self.manabar.LeftText:Hide()
                --     self.manabar.RightText:Hide()
                --     forceNormalTexture = true
                    if (classification == "worldboss" or classification == "elite") then
                            self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame")
                    elseif (classification == "rareelite") then
                            self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame")
                    elseif (classification == "rare") then
                            self.borderTexture:SetTexture("Interface\\TargetingFrame\\UI-TargetingFrame")
                    end
                    
                    --self.levelText:SetPoint("CENTER", self.textureFrame, "CENTER", 72, -22)
                    self.Background:SetHeight(43)
                    self.nameBackground:Hide()
                    self.name:SetPoint("LEFT", self, 15,34)

                    self.healthbar:SetPoint("TOPRIGHT", -108, -26)
                    self.healthbar:SetSize(117, 24)
                    if self.healthbar.LeftText then
                        self.healthbar.LeftText:SetPoint("LEFT", 8, 10)
                    end
                    if self.healthbar.RightText then
                        self.healthbar.RightText:SetPoint("CENTER", 20, 10)
                    end

                    if self.manabar.LeftText then
                       self.manabar.LeftText:SetAlpha(0)
                    end

                    if self.healthbar.TextString then 
                        self.healthbar.TextString:SetPoint("CENTER", -50, 10)
                    end
                    if self.manabar.RightText then
                        self.manabar.RightText:SetPoint("CENTER", 20, -6)
                    end
                    self.manabar:SetPoint("TOPRIGHT", -108, -52)
                    self.manabar:SetSize(117, 9)

                    self.deadText:SetPoint("LEFT", self, 48, 12)
            end
        )

        -- Class portraits in player/target frames
            hooksecurefunc(
                "UnitFramePortrait_Update",
                function(self)
                    if self.portrait then
                        if UnitIsPlayer(self.unit) then
                            local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))]
                            if t then
                                self.portrait:SetTexture([[Interface\Addons\GoodmanUI\Textures\UI-Classes-Circles]])
                                self.portrait:SetTexCoord(unpack(t))
                            end
                        else
                            self.portrait:SetTexCoord(0, 1, 0, 1)
                        end
                    end
                end
            )
      

        -- raid/group frames
        CompactRaidFrameContainer:SetScale(GoodmanUIDB.RAIDFRAMES.SCALE)

        if CompactPartyFrame then
            CompactPartyFrame:SetScale(GoodmanUIDB.RAIDFRAMES.SCALE)
        end

        --This is how you make the raid frames even more resizable
        local n, w, h = "CompactUnitFrameProfilesGeneralOptionsFrame"
        h, w = _G[n .. "HeightSlider"], _G[n .. "WidthSlider"]
        h:SetMinMaxValues(1, 150)
        w:SetMinMaxValues(1, 150)
    end
)

-- -- -- --Pet frame
-- -- -- PetHitIndicator:SetText(nil)
-- -- -- PetHitIndicator.SetText = function()
-- -- -- end

for i,v in pairs({
    PlayerAttackIcon,
    PlayerGuideIcon,
    PlayerFrameBackground,
    PlayerFrameGroupIndicator,
    PlayerFrameLeaderIcon,
    PlayerMasterIcon,
    PlayerLevelText,
    PlayerStatusGlow,
    PlayerPrestigePortrait,
    PlayerPVPIcon,
    TargetFrameToTBackground
    }) do hooksecurefunc(v, "Show", function(s) s:Hide() end)
      v:Show()
      end

     hooksecurefunc("PlayerFrame_UpdateStatus", function()
        for _, v in pairs({
            PlayerStatusTexture,
            PlayerStatusGlow,
            PlayerRestGlow,
            PlayerRestIcon,
            PlayerAttackGlow,
            PlayerAttackBackground
        }) do
            v:Hide()
        end
    end)


------------------
--[[	Patch	]]
------------------
local HookedBars={};

local function ShouldKnowUnitHealth(unit)--	Lua implementation of how health obfuscation works in the current game
--	Note: Totems/Guardians/Etc are considered NPCs when it comes to health obfuscation
	local guid=UnitGUID(unit);
	local unittype=guid and guid:match("^(.-)%-");
	return	(unittype~="Player" and unittype~="Pet")--	Is NPC? (incl. totem/guardian/etc)
	or	(UnitIsUnit(unit,"player") or UnitIsUnit(unit,"pet"))--	Is player or player's pet?
	or	(UnitPlayerOrPetInRaid(unit) or UnitPlayerOrPetInParty(unit));--	Is in party/raid?
end

hooksecurefunc("UnitFrameHealthBar_Update",function(statusbar,unit)
--		Verify if percent lock is set
		if statusbar and not statusbar.lockValues and unit==statusbar.unit and statusbar.showPercentage then
--			Re-evaluate and update text
			local known=ShouldKnowUnitHealth(unit); if known then
				statusbar.showPercentage = false;
				TextStatusBar_UpdateTextString(statusbar);
			end
	end

--	Capture for options
	HookedBars[statusbar]=true;
end);


local showhealthfunc=true and ShouldKnowUnitHealth or _G.ShouldKnowUnitHealth;--	Select between our custom function and Blizzard's version
for statusbar in pairs(HookedBars) do
    local unit=statusbar.unit; if unit then
        statusbar.showPercentage=not showhealthfunc(unit);
        TextStatusBar_UpdateTextString(statusbar);
    end
end


--[[	TextStatusBars	]]
--------------------------
local TextObjects={};
local AnchorSettings={--	Anchors copied from Modern WoW (Relative to TargetFrameTextureFrame)
	[TargetFrameTextureFrame]={
		[TargetFrameHealthBar]={
			TextString={"CENTER",-50,3};
			LeftText={"LEFT",8,3};
			RightText={"RIGHT",-110,3};
		};
		[TargetFrameManaBar]={
			TextString={"CENTER",-50,-8};
			LeftText={"LEFT",8,-8};
			RightText={"RIGHT",-110,-8};
		};
	};
};

for parent,barlist in pairs(AnchorSettings) do
	for bar,anchorlist in pairs(barlist) do
		local tbl={};
		for key,anchor in pairs(anchorlist) do
			local text=parent:CreateFontString(nil,"OVERLAY","TextStatusBarText");
			text:SetPoint(unpack(anchor));
			tbl[key]=text;
		end
		TextObjects[bar]=tbl;
	end
end


local function VerifyStatusBar(bar)
	local tbl=TextObjects[bar];
	if not tbl then return nil; end--	Not one of our bars (Also stops recursion)

--	Scanner
	local valid = true;
	for key,obj in pairs(tbl) do
		local exist=bar[key];
		if exist and exist~=obj then valid=false; break; end
	end
	if valid then return true; end--	No further processing if valid

--	Invalid, do cleanup here
	TextObjects[bar]=nil;--	Remove from our objects list (UI objects can't be garbage-collected, this just orphans them)
	for key,obj in pairs(tbl) do
		if bar[key]==obj then bar[key]=nil; end--	Remove if still set (another object in the group was overwritten)
		obj:Hide();--	Hide object
	end

	TextStatusBar_UpdateTextString(bar);--	Update other addons' text
	return false;--	Return as invalid
end

for bar,entry in pairs(TextObjects) do
    if VerifyStatusBar(bar) then
        for key,obj in pairs(entry) do
            if not true then obj:Hide(); end--	Hide if disabling (TextStatusBar_UpdateTextString() will autoshow when necessary)
            bar[key]=true and obj or nil;--	Apply if enabled
        end

        TextStatusBar_UpdateTextString(bar);
    end
end

hooksecurefunc("TextStatusBar_UpdateTextStringWithValues",VerifyStatusBar);